/*
  ➑̂̎Ȉʒu
  Satofumi KAMIMURA
  $Id$
*/

#include "bodyPosition.h"
#include "isincos.h"


void initBodyPositionInfo(bodyPosition_t *bodyPos, bodyInfo_t *bodyInfo) {
  int i;
  
  bodyPos->body = bodyInfo;

  for (i = 0; i < 2; ++i) {
    bodyPos->cnt_integer[i] = 0;
    bodyPos->cnt_decimal[i] = 0;
  }
  bodyPos->rotate_num = 0;

  // ԗւ̒a傫̎ԗւ cnt_per_m p
  bodyPos->cnt_per_m = (bodyInfo->whl[WHL_RIGHT]->cnt_per_m >
			bodyInfo->whl[WHL_LEFT]->cnt_per_m) ?
    bodyInfo->whl[WHL_RIGHT]->cnt_per_m : bodyInfo->whl[WHL_LEFT]->cnt_per_m;

  // mm/sec x̌vZp
  bodyPos->cnt2mm_const = ((1 << 16) * 1000) / bodyPos->cnt_per_m;

  // straight = right + left  2 ŊȂ߂̒
  bodyPos->cnt_per_m <<= 1;

  // ]p[^
  bodyPos->div16_cnt = 0;

  // !!! Aߑł RIGHT pĂ̂͂܂B傫pׂ
  bodyPos->div16_cnt_max = (long)(BODY_TREAD_MM * M_PI * WHL_CNT_PER_MM_RIGHT);
  bodyPos->div16_cnt_max <<= 1;
  bodyPos->div16_cnt_mul = (long)((1 << DIV16_MUL_SHIFT)
				  / bodyPos->div16_cnt_max);

  // Wn
  initCoordinateInfo(&bodyPos->body_crd);

  bodyPos->straight_cnt_vel = 0;
  bodyPos->rotate_cnt_vel = 0;
}


// !!! 
static int adjustEncCnt(int cnt, wheelInfo_t *whl) {
  // !!! whl lāACꂽ cnt Ԃׂ
  return cnt;
}


void updateBodyPosition(bodyPosition_t *bodyPos, int right_cnt, int left_cnt) {
  enum { X = COORD_X, Y = COORD_Y };
  int i;
  int adjust_right_cnt, adjust_left_cnt;
  long cnt[2];

  /* GR[_l̏d𑵂݂ */
  adjust_right_cnt = adjustEncCnt(right_cnt, bodyPos->body->whl[WHL_RIGHT]);
  adjust_left_cnt = adjustEncCnt(left_cnt, bodyPos->body->whl[WHL_LEFT]);

  // iA]x̌vZ
  bodyPos->straight_cnt_vel = adjust_right_cnt + adjust_left_cnt;
  bodyPos->rotate_cnt_vel = adjust_right_cnt - adjust_left_cnt;
  bodyPos->div16_cnt += bodyPos->rotate_cnt_vel;

  // div16 vZ
  if (bodyPos->div16_cnt < 0) {
    bodyPos->div16_cnt += bodyPos->div16_cnt_max;
    --(bodyPos->rotate_num);
  } else if (bodyPos->div16_cnt >= bodyPos->div16_cnt_max) {
    bodyPos->div16_cnt -= bodyPos->div16_cnt_max;
    ++(bodyPos->rotate_num);
  }
  bodyPos->body_crd.div16
    = (bodyPos->div16_cnt * bodyPos->div16_cnt_mul) >> (DIV16_MUL_SHIFT - 16);
  
  // X, Y ̈ړʂvZ
  cnt[X] = (bodyPos->straight_cnt_vel * icos(bodyPos->body_crd.div16))
    + bodyPos->cnt_decimal[X];
  cnt[Y] = (bodyPos->straight_cnt_vel * isin(bodyPos->body_crd.div16))
    + bodyPos->cnt_decimal[Y];

  for (i = 0; i < 2; ++i) {
    int add = cnt[i] >> ISINCOS_VALUE_SHIFT;
    bodyPos->cnt_integer[i] += add;
    bodyPos->cnt_decimal[i] = cnt[i] - (add << ISINCOS_VALUE_SHIFT);

    // m ̈ړʂψʂZ
    while (bodyPos->cnt_integer[i] >= bodyPos->cnt_per_m) {
      bodyPos->cnt_integer[i] -= bodyPos->cnt_per_m;
      ++(bodyPos->body_crd.m[i]);
    }
    while (bodyPos->cnt_integer[i] < 0) {
      bodyPos->cnt_integer[i] += bodyPos->cnt_per_m;
      --(bodyPos->body_crd.m[i]);
    }
    
    // km ̈ړʂ̕ψʂZ
    while (bodyPos->body_crd.m[i] >= 1000) {
      bodyPos->body_crd.m[i] -= 1000;
      ++(bodyPos->body_crd.km[i]);
    }
    while (bodyPos->body_crd.m[i] < 0) {
      bodyPos->body_crd.m[i] += 1000;
      --(bodyPos->body_crd.km[i]);
    }

    // mm ̈ʒuvZ
    bodyPos->body_crd.mm[i] =
      (1000 * bodyPos->cnt_integer[i]) / bodyPos->cnt_per_m;
  }
}


void updateCoordinatePosition(coordinateInfo_t *crd,
			      bodyPosition_t *bodyPos) {
  int i;
  
  for (i = 0; i < 2; ++i) {
    crd->km[i] = bodyPos->body_crd.km[i];
    crd->m[i] = bodyPos->body_crd.m[i];
    crd->mm[i] = bodyPos->body_crd.mm[i];
    crd->mm256[i] = bodyPos->body_crd.mm256[i];
  }
  crd->div16 = bodyPos->body_crd.div16;
}
